DELETE FROM report_sql WHERE computer={?Computer};

-------------------------------------------------------------------------------------------------------------
-- POMEMBNO: NUM1 je zaporedna tevilka vrstice, ki se bo izpisala na reportu (vrstni red!)
-- vsi izrauni so v .sql, report samo izpie vsebino tabele report_sql
-- vsaka celica na reportu se rauna posebej z loenim SQL-om (glede na kategorijo storitve; kategorije so zapeene)
-------------------------------------------------------------------------------------------------------------

-- num1  = tevilka vrstice na reportu
-- str1  = naslovna vrstica
-- str2 do str12 = podatki za izpis
-- num20 = 0 osnovni grupi (Permament / Casual)
-- num20 = 1 / 2 / 3: naslovna vrstica (zelena) / glava podatkov(oranna) / podatki (bela)

-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------
-- PERMANENT VESSELS
-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------
INSERT INTO report_sql (computer, num1, str1, num20, date3, date4)
VALUES ({?Computer}, 1, 'PERMANENT VESSELS', 0, {?dFrom}, {?dTo});

-------------------------------------------------------------------------------------------------------------
-- Paid Permanent Vessels Arrived in SHM and paying monthly for berth
-------------------------------------------------------------------------------------------------------------
-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, str7, num20)
SELECT {?Computer}, 5, rownum, CASE WHEN a.kat='99Cats' THEN 'Cats' ELSE m_nnkateg.opis END, a.privez, a.ime, a.kupec, a.datum_od, a.datum_do, a.n_racuna, m_nnkateg.sifra, 10 FROM (
SELECT CASE WHEN m_storitve.storitev='15' THEN '99Cats' ELSE m_storitve.kat END kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec,
       m_storitve.datum_od, m_storitve.datum_do, 'Inv. ' || m_storitve.n_racuna n_racuna, nvl(p1.n_priveza, p2.n_priveza) privez
FROM m_storitve
LEFT OUTER JOIN nnprivez p1 ON m_storitve.id_privez=p1.id_privez
LEFT OUTER JOIN m_pogodbe ON m_storitve.id_pogodbe=m_pogodbe.id_pogodbe
LEFT OUTER JOIN nnprivez p2 ON m_pogodbe.id_privez=p2.id_privez
LEFT OUTER JOIN plovila p ON m_storitve.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
WHERE m_storitve.id_storitve IN (
      SELECT max(m_storitve.id_storitve)
      FROM m_storitve
      LEFT OUTER JOIN nnprivez p1 ON m_storitve.id_privez=p1.id_privez
      LEFT OUTER JOIN m_pogodbe ON m_storitve.id_pogodbe=m_pogodbe.id_pogodbe
      LEFT OUTER JOIN nnprivez p2 ON m_pogodbe.id_privez=p2.id_privez
      LEFT OUTER JOIN plovila p ON m_storitve.id_plovila=p.id
      LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
      WHERE m_storitve.storitev IN ('14','15') AND m_storitve.kat is not null
      AND m_storitve.datum_od <= {?dTo} AND nvl(m_storitve.datum_do,m_storitve.datum_od) >= {?dFrom}
      AND (m_storitve.n_racuna IS NOT NULL AND m_storitve.n_racuna <> 'STORNO')
      AND nvl(p2.occupancy_statistics, p1.occupancy_statistics) = 'Y'
      AND (SELECT count(*)
           FROM rezervac_detail
           JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id
           WHERE rezervac.id_plovila=m_storitve.id_plovila
           AND rezervac_detail.status_rezervac = 1
           AND rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >= {?dFrom}
           AND rezervac.storno IS NULL) > 0
      AND (SELECT count(*)
           FROM m_pogodbe
           WHERE m_pogodbe.id_plovila=m_storitve.id_plovila
           AND (m_pogodbe.status IN ('A', 'O', 'P')
           AND m_pogodbe.datum_zacetka <= {?dTo} AND nvl(m_pogodbe.datum_konca,{?dFrom}) >= {?dFrom}
           OR  m_pogodbe.status IN ('R')
           AND m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_prekinitve >= {?dFrom})) > 0
GROUP BY m_storitve.id_plovila)
ORDER BY kat, privez) a
LEFT OUTER JOIN m_nnkateg ON a.kat=m_nnkateg.sifra and m_nnkateg.sifra_sklopa='3';

INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 2, 'Paid Permanent Vessels Arrived in SHM and paying monthly for berth', 1);

INSERT INTO report_sql (computer, num1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, num20)
VALUES ({?Computer}, 3, '12m', '14m', '16m', '18m', '20m', '22m', '25m', '28m', '>28m', 'Cats', 'TOTAL', 2);

INSERT INTO report_sql (computer, num1, num20)
VALUES ({?Computer}, 4, 3);

UPDATE report_sql r1 SET r1.str2 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='02'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str3 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='04'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str4 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='05'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str5 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='06'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str6 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='07'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str7 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='08'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str8 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='09'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str9 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='10'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str10 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='11'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str11 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str2 ='Cats'
       AND r2.num1=5 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4 AND computer={?Computer};

UPDATE report_sql SET str12 = trim(to_char(to_number(str2) + to_number(str3) + to_number(str4) + to_number(str5) + to_number(str6) + 
                                           to_number(str7) + to_number(str8) + to_number(str9) + to_number(str10) + to_number(str11),'9,990'))
WHERE num1=4 AND computer={?Computer};

-------------------------------------------------------------------------------------------------------------
-- Paid Permanent No Vessel but paying monthly for Berth
-------------------------------------------------------------------------------------------------------------
-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, str7, num20)
SELECT {?Computer}, 1005, rownum, CASE WHEN a.kat='99Cats' THEN 'Cats' ELSE m_nnkateg.opis END, a.privez, a.ime, a.kupec, a.datum_od, a.datum_do, a.n_racuna, m_nnkateg.sifra, 10 FROM (
SELECT CASE WHEN m_storitve.storitev='15' THEN '99Cats' ELSE m_storitve.kat END kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec,
       m_storitve.datum_od, m_storitve.datum_do, 'Inv. ' || m_storitve.n_racuna n_racuna, nvl(p1.n_priveza, p2.n_priveza) privez
FROM m_storitve
LEFT OUTER JOIN nnprivez p1 ON m_storitve.id_privez=p1.id_privez
LEFT OUTER JOIN m_pogodbe ON m_storitve.id_pogodbe=m_pogodbe.id_pogodbe
LEFT OUTER JOIN nnprivez p2 ON m_pogodbe.id_privez=p2.id_privez
LEFT OUTER JOIN plovila p ON m_storitve.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
WHERE m_storitve.id_storitve IN (
      SELECT max(m_storitve.id_storitve)
      FROM m_storitve
      LEFT OUTER JOIN nnprivez p1 ON m_storitve.id_privez=p1.id_privez
      LEFT OUTER JOIN m_pogodbe ON m_storitve.id_pogodbe=m_pogodbe.id_pogodbe
      LEFT OUTER JOIN nnprivez p2 ON m_pogodbe.id_privez=p2.id_privez
      LEFT OUTER JOIN plovila p ON m_storitve.id_plovila=p.id
      LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
      WHERE m_storitve.storitev IN ('14','15') AND m_storitve.kat is not null
      AND m_storitve.datum_od <= {?dTo} AND nvl(m_storitve.datum_do,m_storitve.datum_od) >= {?dFrom}
      AND (m_storitve.n_racuna IS NOT NULL AND m_storitve.n_racuna <> 'STORNO')
      AND nvl(p2.occupancy_statistics, p1.occupancy_statistics) = 'Y'
      AND (SELECT count(*)
           FROM rezervac_detail
           JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id
           WHERE rezervac.id_plovila=m_storitve.id_plovila
           AND rezervac_detail.status_rezervac = 1
           AND rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >= {?dFrom}
           AND rezervac.storno IS NULL) = 0
      AND (SELECT count(*) 
            FROM rezervac_detail 
            JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id 
            WHERE rezervac.id_plovila=m_storitve.id_plovila
            AND rezervac_detail.status_rezervac = 1
            AND rezervac_detail.datum_do > {?dTo}
            AND rezervac.storno IS NULL) > 0
      AND (SELECT count(*)
           FROM m_pogodbe
           WHERE m_pogodbe.id_plovila=m_storitve.id_plovila
           AND (m_pogodbe.status IN ('A', 'O', 'P')
           AND m_pogodbe.datum_zacetka <= {?dTo} AND nvl(m_pogodbe.datum_konca,{?dFrom}) >= {?dFrom}
           OR  m_pogodbe.status IN ('R')
           AND m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_prekinitve >= {?dFrom})) > 0
GROUP BY m_storitve.id_plovila)
ORDER BY kat, privez) a
LEFT OUTER JOIN m_nnkateg ON a.kat=m_nnkateg.sifra and m_nnkateg.sifra_sklopa='3';

INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 1002, 'Paid Permanent No Vessel but paying monthly for Berth', 1);

INSERT INTO report_sql (computer, num1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, num20)
VALUES ({?Computer}, 1003, '12m', '14m', '16m', '18m', '20m', '22m', '25m', '28m', '>28m', 'Cats', 'TOTAL', 2);

INSERT INTO report_sql (computer, num1, num20)
VALUES ({?Computer}, 1004, 3);

UPDATE report_sql r1 SET r1.str2 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='02'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str3 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='04'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str4 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='05'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str5 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='06'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str6 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='07'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str7 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='08'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str8 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='09'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str9 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='10'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str10 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='11'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str11 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str2 ='Cats'
       AND r2.num1=1005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=1004 AND computer={?Computer};

UPDATE report_sql SET str12 = trim(to_char(to_number(str2) + to_number(str3) + to_number(str4) + to_number(str5) + to_number(str6) + 
                                           to_number(str7) + to_number(str8) + to_number(str9) + to_number(str10) + to_number(str11),'9,990'))
WHERE num1=1004 AND computer={?Computer};

-------------------------------------------------------------------------------------------------------------
-- Paid Security Deposit and One Month - Arriving next month
-------------------------------------------------------------------------------------------------------------
INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 2002, 'Paid Security Deposit and One Month - Arriving next month (between ' || to_char({?dTo}+1,'dd/mm/yyyy') || ' and ' || to_char(add_months({?dTo},1),'dd/mm/yyyy') || ')', 1);

INSERT INTO report_sql (computer, num1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, num20)
VALUES ({?Computer}, 2003, '12m', '14m', '16m', '18m', '20m', '22m', '25m', '28m', '>28m', 'Cats', 'TOTAL', 2);

INSERT INTO report_sql (computer, num1, num20)
VALUES ({?Computer}, 2004, 3);

UPDATE report_sql SET str2 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='02') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str3 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='04') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str4 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='05') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str5 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='06') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str6 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='07') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str7 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='08') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str8 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='09') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str9 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='10') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str10 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='11') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str11 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '15') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=2004 AND computer={?Computer};

UPDATE report_sql SET str12 = trim(to_char(to_number(str2) + to_number(str3) + to_number(str4) + to_number(str5) + to_number(str6) + 
                                           to_number(str7) + to_number(str8) + to_number(str9) + to_number(str10) + to_number(str11),'9,990'))
WHERE num1=2004 AND computer={?Computer};


-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, num20)
SELECT {?Computer}, 2005, rownum, CASE WHEN a.kat='99Cats' THEN 'Cats' ELSE m_nnkateg.opis END, a.privez, a.ime, a.kupec, a.datum_zacetka, a.datum_konca, a.n_racuna, 10 FROM (
SELECT CASE WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='15')  > 0 THEN '99Cats'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='02')  > 0 THEN '02'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='04')  > 0 THEN '04'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='05')  > 0 THEN '05'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='06')  > 0 THEN '06'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='07')  > 0 THEN '07'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='08')  > 0 THEN '08'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='09')  > 0 THEN '09'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='10')  > 0 THEN '10'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='11')  > 0 THEN '11'
      END kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, 
      m_pogodbe.datum_zacetka, m_pogodbe.datum_konca, 'Contract ' || m_pogodbe.n_pogodbe n_racuna, nnprivez.n_priveza privez
FROM m_pogodbe
LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
LEFT OUTER JOIN plovila p ON m_pogodbe.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
WHERE m_pogodbe.datum_zacetka > {?dTo} AND m_pogodbe.datum_zacetka <= add_months({?dTo},1)
      AND m_pogodbe.status = 'O'
      AND nnprivez.occupancy_statistics='Y'
      AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev in ('14','15') ) > 0
      AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0
ORDER BY 1,nnprivez.n_priveza) a
LEFT OUTER JOIN m_nnkateg ON a.kat=m_nnkateg.sifra and m_nnkateg.sifra_sklopa='3'
;

-------------------------------------------------------------------------------------------------------------
-- Paid Security Deposit and One Month - Arrival in the future
-------------------------------------------------------------------------------------------------------------
INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 3002, 'Paid Security Deposit and One Month - Arrival in the future (after ' || to_char(add_months({?dTo}+1,1),'dd/mm/yyyy') || ')', 1);

INSERT INTO report_sql (computer, num1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, num20)
VALUES ({?Computer}, 3003, '12m', '14m', '16m', '18m', '20m', '22m', '25m', '28m', '>28m', 'Cats', 'TOTAL', 2);

INSERT INTO report_sql (computer, num1, num20)
VALUES ({?Computer}, 3004, 3);

UPDATE report_sql SET str2 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='02') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str3 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='04') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str4 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='05') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str5 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='06') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str6 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='07') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str7 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='08') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str8 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='09') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str9 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='10') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str10 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '14' and m_vzorci_ps.kat='11') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str11 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
       AND m_pogodbe.status = 'O'
       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '15') > 0
       AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0),'9,990'))
WHERE num1=3004 AND computer={?Computer};

UPDATE report_sql SET str12 = trim(to_char(to_number(str2) + to_number(str3) + to_number(str4) + to_number(str5) + to_number(str6) + 
                                           to_number(str7) + to_number(str8) + to_number(str9) + to_number(str10) + to_number(str11),'9,990'))
WHERE num1=3004 AND computer={?Computer};

-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, num20)
SELECT {?Computer}, 3005, rownum, CASE WHEN a.kat='99Cats' THEN 'Cats' ELSE m_nnkateg.opis END, a.privez, a.ime, a.kupec, a.datum_zacetka, a.datum_konca, a.n_racuna, 10 FROM (
SELECT CASE WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='15')  > 0 THEN '99Cats'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='02')  > 0 THEN '02'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='04')  > 0 THEN '04'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='05')  > 0 THEN '05'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='06')  > 0 THEN '06'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='07')  > 0 THEN '07'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='08')  > 0 THEN '08'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='09')  > 0 THEN '09'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='10')  > 0 THEN '10'
            WHEN (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev ='14' AND m_vzorci_ps.kat='11')  > 0 THEN '11'
      END kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, 
      m_pogodbe.datum_zacetka, m_pogodbe.datum_konca, 'Contract ' || m_pogodbe.n_pogodbe n_racuna, nnprivez.n_priveza privez
FROM m_pogodbe
LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
LEFT OUTER JOIN plovila p ON m_pogodbe.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
WHERE m_pogodbe.datum_zacetka > add_months({?dTo},1)
      AND m_pogodbe.status = 'O'
      AND nnprivez.occupancy_statistics='Y'
      AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev in ('14','15') ) > 0
      AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_pogodbe.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0
ORDER BY 1,nnprivez.n_priveza) a
LEFT OUTER JOIN m_nnkateg ON a.kat=m_nnkateg.sifra and m_nnkateg.sifra_sklopa='3'
;

-------------------------------------------------------------------------------------------------------------
-- Departed but will be Returning (kept security deposit)
-------------------------------------------------------------------------------------------------------------
-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, str7, num20)
SELECT {?Computer}, 4005, rownum, CASE WHEN a.kat='99Cats' THEN 'Cats' ELSE m_nnkateg.opis END, a.privez, a.ime, a.kupec, a.datum_od, a.datum_do, a.n_racuna, m_nnkateg.sifra, 10 FROM (
SELECT CASE WHEN m_storitve.storitev='15' THEN '99Cats' ELSE m_storitve.kat END kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec,
       m_storitve.datum_od, m_storitve.datum_do, 'Inv. ' || m_storitve.n_racuna n_racuna, nvl(p1.n_priveza, p2.n_priveza) privez
FROM m_storitve
LEFT OUTER JOIN nnprivez p1 ON m_storitve.id_privez=p1.id_privez
LEFT OUTER JOIN m_pogodbe ON m_storitve.id_pogodbe=m_pogodbe.id_pogodbe
LEFT OUTER JOIN nnprivez p2 ON m_pogodbe.id_privez=p2.id_privez
LEFT OUTER JOIN plovila p ON m_storitve.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
WHERE m_storitve.id_storitve IN (
      SELECT max(m_storitve.id_storitve)
      FROM m_storitve
      LEFT OUTER JOIN nnprivez p1 ON m_storitve.id_privez=p1.id_privez
      LEFT OUTER JOIN m_pogodbe ON m_storitve.id_pogodbe=m_pogodbe.id_pogodbe
      LEFT OUTER JOIN nnprivez p2 ON m_pogodbe.id_privez=p2.id_privez
      LEFT OUTER JOIN plovila p ON m_storitve.id_plovila=p.id
      LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
      WHERE m_storitve.storitev IN ('14','15') AND m_storitve.kat is not null
      AND m_storitve.datum_od <= {?dTo} AND nvl(m_storitve.datum_do,m_storitve.datum_od) >= {?dFrom}
      AND (m_storitve.n_racuna IS NOT NULL AND m_storitve.n_racuna <> 'STORNO')
      AND nvl(p2.occupancy_statistics, p1.occupancy_statistics) = 'Y'
-- na datum_do niso v marini
      AND (SELECT count(*)
           FROM rezervac_detail
           JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id
           WHERE rezervac.id_plovila=m_storitve.id_plovila
           AND rezervac_detail.status_rezervac = 1
           AND rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >= {?dTo}
           AND rezervac.storno IS NULL) = 0
-- pred datum_od so bila v marini
      AND (SELECT count(*)
           FROM rezervac_detail
           JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id
           WHERE rezervac.id_plovila=m_storitve.id_plovila
           AND rezervac_detail.status_rezervac = 1
           AND rezervac_detail.datum_od < {?dFrom}
           AND rezervac.storno IS NULL) > 0
-- po datumu_do bodo spet v marini
      AND (SELECT count(*) 
            FROM rezervac_detail 
            JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id 
            WHERE rezervac.id_plovila=m_storitve.id_plovila
            AND rezervac_detail.status_rezervac = 1
            AND rezervac_detail.datum_do > {?dTo}
            AND rezervac.storno IS NULL) = 0
      AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_storitve.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) > 0
GROUP BY m_storitve.id_plovila)
ORDER BY kat, privez) a
LEFT OUTER JOIN m_nnkateg ON a.kat=m_nnkateg.sifra and m_nnkateg.sifra_sklopa='3';

INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 4002, 'Departed but will be Returning (kept security deposit)', 1);

INSERT INTO report_sql (computer, num1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, num20)
VALUES ({?Computer}, 4003, '12m', '14m', '16m', '18m', '20m', '22m', '25m', '28m', '>28m', 'Cats', 'TOTAL', 2);

INSERT INTO report_sql (computer, num1, num20)
VALUES ({?Computer}, 4004, 3);

UPDATE report_sql r1 SET r1.str2 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='02'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str3 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='04'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str4 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='05'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str5 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='06'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str6 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='07'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str7 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='08'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str8 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='09'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str9 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='10'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str10 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='11'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str11 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str2 ='Cats'
       AND r2.num1=4005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=4004 AND computer={?Computer};

UPDATE report_sql SET str12 = trim(to_char(to_number(str2) + to_number(str3) + to_number(str4) + to_number(str5) + to_number(str6) + 
                                           to_number(str7) + to_number(str8) + to_number(str9) + to_number(str10) + to_number(str11),'9,990'))
WHERE num1=4004 AND computer={?Computer};

-------------------------------------------------------------------------------------------------------------
-- Departure Notice Received
-------------------------------------------------------------------------------------------------------------
-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, str7, num20)
SELECT {?Computer}, 5005, rownum, CASE WHEN a.kat='99Cats' THEN 'Cats' ELSE m_nnkateg.opis END, a.privez, a.ime, a.kupec, a.datum_od, a.datum_do, a.n_racuna, m_nnkateg.sifra, 10 FROM (
SELECT CASE WHEN m_storitve.storitev='15' THEN '99Cats' ELSE m_storitve.kat END kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec,
       m_storitve.datum_od, m_storitve.datum_do, 'Inv. ' || m_storitve.n_racuna n_racuna, nvl(p1.n_priveza, p2.n_priveza) privez
FROM m_storitve
LEFT OUTER JOIN nnprivez p1 ON m_storitve.id_privez=p1.id_privez
LEFT OUTER JOIN m_pogodbe ON m_storitve.id_pogodbe=m_pogodbe.id_pogodbe
LEFT OUTER JOIN nnprivez p2 ON m_pogodbe.id_privez=p2.id_privez
LEFT OUTER JOIN plovila p ON m_storitve.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
WHERE m_storitve.id_storitve IN (
      SELECT max(m_storitve.id_storitve)
      FROM m_storitve
      LEFT OUTER JOIN nnprivez p1 ON m_storitve.id_privez=p1.id_privez
      LEFT OUTER JOIN m_pogodbe ON m_storitve.id_pogodbe=m_pogodbe.id_pogodbe
      LEFT OUTER JOIN nnprivez p2 ON m_pogodbe.id_privez=p2.id_privez
      LEFT OUTER JOIN plovila p ON m_storitve.id_plovila=p.id
      LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
      WHERE m_storitve.storitev IN ('14','15') AND m_storitve.kat is not null
      AND m_storitve.datum_od <= {?dTo} AND nvl(m_storitve.datum_do,m_storitve.datum_od) >= {?dFrom}
      AND (m_storitve.n_racuna IS NOT NULL AND m_storitve.n_racuna <> 'STORNO')
      AND nvl(p2.occupancy_statistics, p1.occupancy_statistics) = 'Y'
-- na datum_do niso v marini
      AND (SELECT count(*)
           FROM rezervac_detail
           JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id
           WHERE rezervac.id_plovila=m_storitve.id_plovila
           AND rezervac_detail.status_rezervac = 1
           AND rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >= {?dTo}
           AND rezervac.storno IS NULL) = 0
-- pred datum_od so bila v marini
      AND (SELECT count(*)
           FROM rezervac_detail
           JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id
           WHERE rezervac.id_plovila=m_storitve.id_plovila
           AND rezervac_detail.status_rezervac = 1
           AND rezervac_detail.datum_od < {?dFrom}
           AND rezervac.storno IS NULL) > 0
-- po datumu_do ne bodo v marini
      AND (SELECT count(*) 
            FROM rezervac_detail 
            JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id 
            WHERE rezervac.id_plovila=m_storitve.id_plovila
            AND rezervac_detail.status_rezervac = 1
            AND rezervac_detail.datum_do > {?dTo}
            AND rezervac.storno IS NULL) = 0
      AND nvl((SELECT sum(za_placilo) FROM saldkont WHERE id_kupca=m_storitve.id_lastnika AND vrsta_racuna='DP' AND datum <= {?dTo}),0) = 0
GROUP BY m_storitve.id_plovila)
ORDER BY kat, privez) a
LEFT OUTER JOIN m_nnkateg ON a.kat=m_nnkateg.sifra and m_nnkateg.sifra_sklopa='3';

INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 5002, 'Departure Notice Received', 1);

INSERT INTO report_sql (computer, num1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, num20)
VALUES ({?Computer}, 5003, '12m', '14m', '16m', '18m', '20m', '22m', '25m', '28m', '>28m', 'Cats', 'TOTAL', 2);

INSERT INTO report_sql (computer, num1, num20)
VALUES ({?Computer}, 5004, 3);

UPDATE report_sql r1 SET r1.str2 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='02'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str3 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='04'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str4 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='05'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str5 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='06'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str6 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='07'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str7 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='08'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str8 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='09'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str9 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='10'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str10 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str7 ='11'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql r1 SET r1.str11 = trim(to_char((
       SELECT count(*) 
       FROM report_sql r2
       WHERE r2.str2 ='Cats'
       AND r2.num1=5005 AND r2.computer={?Computer}),'9,990'))
WHERE num1=5004 AND computer={?Computer};

UPDATE report_sql SET str12 = trim(to_char(to_number(str2) + to_number(str3) + to_number(str4) + to_number(str5) + to_number(str6) + 
                                           to_number(str7) + to_number(str8) + to_number(str9) + to_number(str10) + to_number(str11),'9,990'))
WHERE num1=5004 AND computer={?Computer};

-------------------------------------------------------------------------------------------------------------
-- Totals (for Permanent vessels)
-------------------------------------------------------------------------------------------------------------
INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 6002, 'Totals', 4);

INSERT INTO report_sql (computer, num1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, num20)
VALUES ({?Computer}, 6003, '12m', '14m', '16m', '18m', '20m', '22m', '25m', '28m', '>28m', 'Cats', 'TOTAL', 2);

INSERT INTO report_sql (computer, num1, num20)
VALUES ({?Computer}, 6004, 3);

UPDATE report_sql SET str2 = trim(to_char((SELECT to_number(str2) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str2) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str2) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str2) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str2) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str2) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str3 = trim(to_char((SELECT to_number(str3) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str3) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str3) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str3) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str3) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str3) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str4 = trim(to_char((SELECT to_number(str4) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str4) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str4) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str4) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str4) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str4) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str5 = trim(to_char((SELECT to_number(str5) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str5) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str5) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str5) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str5) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str5) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str6 = trim(to_char((SELECT to_number(str6) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str6) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str6) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str6) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str6) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str6) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str7 = trim(to_char((SELECT to_number(str7) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str7) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str7) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str7) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str7) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str7) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str8 = trim(to_char((SELECT to_number(str8) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str8) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str8) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str8) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str8) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str8) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str9 = trim(to_char((SELECT to_number(str9) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str9) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str9) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str9) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str9) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str9) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str10 = trim(to_char((SELECT to_number(str10) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str10) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str10) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str10) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str10) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str10) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str11 = trim(to_char((SELECT to_number(str11) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str11) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str11) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str11) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str11) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str11) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};
UPDATE report_sql SET str12 = trim(to_char((SELECT to_number(str12) FROM report_sql WHERE num1=4 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str12) FROM report_sql WHERE num1=1004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str12) FROM report_sql WHERE num1=2004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str12) FROM report_sql WHERE num1=3004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str12) FROM report_sql WHERE num1=4004 AND nvl(num20,0) <> 10 AND computer={?Computer}) +
                                          (SELECT to_number(str12) FROM report_sql WHERE num1=5004 AND nvl(num20,0) <> 10 AND computer={?Computer}),'9,990'))
WHERE num1=6004 AND computer={?Computer};

UPDATE report_sql SET num12 = (SELECT to_number(str12) FROM report_sql WHERE num1 = 3004 AND nvl(num20,0) <> 10 AND computer={?Computer})
WHERE num1=6004 AND computer={?Computer};

UPDATE report_sql SET num13 = (SELECT to_number(str12) FROM report_sql WHERE num1 = 4004 AND nvl(num20,0) <> 10 AND computer={?Computer})
WHERE num1=6004 AND computer={?Computer};

-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------
-- OTHER VESSELS
-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------
INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 7001, 'OTHER VESSELS', 0);
-------------------------------------------------------------------------------------------------------------
-- Paid Permanent Vessels Arrived in SHM and paying monthly for berth
-------------------------------------------------------------------------------------------------------------
INSERT INTO report_sql (computer, num1, str2, str3, str4, str5, str12, num20)
VALUES ({?Computer}, 7002, 'Jetski Paid Arrived', 'Jetski Paid Not Arrived', 'Trailer Storage Our Clients', 'Trailer & Boat Storage Not Berth Clients', 'TOTAL', 5);

INSERT INTO report_sql (computer, num1, num20)
VALUES ({?Computer}, 7004, 6);

UPDATE report_sql SET str2 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_konca >= {?dFrom}
       AND m_pogodbe.status IN ('O', 'P')
--       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '21') > 0
       AND (SELECT count(*) 
            FROM rezervac_detail 
            JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id 
            WHERE rezervac.id_plovila=m_pogodbe.id_plovila
            AND rezervac_detail.status_rezervac = 1
            AND rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >= {?dTo}
            AND rezervac.storno IS NULL) > 0),'9,990'))
WHERE num1=7004 AND computer={?Computer};

UPDATE report_sql SET str3 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_konca >= {?dFrom}
       AND m_pogodbe.status IN ('O', 'P')
--       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '21') > 0
       AND (SELECT count(*) 
            FROM rezervac_detail 
            JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id 
            WHERE rezervac.id_plovila=m_pogodbe.id_plovila
            AND rezervac_detail.status_rezervac = 1
            AND rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >= {?dTo}
            AND rezervac.storno IS NULL) = 0),'9,990'))
WHERE num1=7004 AND computer={?Computer};

UPDATE report_sql SET str4 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka<= {?dTo} AND m_pogodbe.datum_konca >= {?dFrom}
       AND m_pogodbe.status in ('O','P')
--       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '42' and m_vzorci_ps.kat='3') > 0),'9,990'))
WHERE num1=7004 AND computer={?Computer};

UPDATE report_sql SET str5 = trim(to_char((
       SELECT count(*) 
       FROM m_pogodbe
       LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
       WHERE m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_konca >= {?dFrom}
       AND m_pogodbe.status IN ('O', 'P')
--       AND nnprivez.occupancy_statistics='Y'
       AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '42' and m_vzorci_ps.kat in ('1','2')) > 0),'9,990'))
WHERE num1=7004 AND computer={?Computer};

UPDATE report_sql SET str12 = trim(to_char(to_number(str2) + to_number(str3) + to_number(str4) + to_number(str5),'9,990'))
WHERE num1=7004 AND computer={?Computer};

-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, num20)
SELECT {?Computer}, 7005, rownum,null, a.privez, a.ime, a.kupec, a.datum_zacetka, a.datum_konca, a.n_racuna, 10 FROM (
SELECT 1 kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, 
       m_pogodbe.datum_zacetka, m_pogodbe.datum_konca, 'JS Arrived' n_racuna, nnprivez.n_priveza privez
FROM m_pogodbe
LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
LEFT OUTER JOIN plovila p ON m_pogodbe.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
       WHERE m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_konca >= {?dFrom}
AND m_pogodbe.status IN ('O', 'P')
--       AND nnprivez.occupancy_statistics='Y'
AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '21') > 0
AND (SELECT count(*)
FROM rezervac_detail
JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id
     WHERE rezervac.id_plovila=m_pogodbe.id_plovila
     AND rezervac_detail.status_rezervac = 1
     AND rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >= {?dTo}
     AND rezervac.storno IS NULL) > 0
UNION ALL
SELECT 2 kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, 
       m_pogodbe.datum_zacetka, m_pogodbe.datum_konca, 'JS Not Arrived' n_racuna, nnprivez.n_priveza privez
FROM m_pogodbe
LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
LEFT OUTER JOIN plovila p ON m_pogodbe.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
       WHERE m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_konca >= {?dFrom}
AND m_pogodbe.status IN ('O', 'P')
--       AND nnprivez.occupancy_statistics='Y'
AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '21') > 0
AND (SELECT count(*)
FROM rezervac_detail
JOIN rezervac on rezervac_detail.id_rezervac=rezervac.id
     WHERE rezervac.id_plovila=m_pogodbe.id_plovila
     AND rezervac_detail.status_rezervac = 1
     AND rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >= {?dTo}
     AND rezervac.storno IS NULL) = 0
UNION ALL
SELECT 3 kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, 
       m_pogodbe.datum_zacetka, m_pogodbe.datum_konca, 'Trailer Our Clients' n_racuna, nnprivez.n_priveza privez
FROM m_pogodbe
LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
LEFT OUTER JOIN plovila p ON m_pogodbe.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
       WHERE m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_konca >= {?dFrom}
AND m_pogodbe.status IN ('O', 'P')
--       AND nnprivez.occupancy_statistics='Y'
AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '42' and m_vzorci_ps.kat='3') > 0
UNION ALL
SELECT 4 kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, 
       m_pogodbe.datum_zacetka, m_pogodbe.datum_konca, 'Trailer Not Berth Clients' n_racuna, nnprivez.n_priveza privez
FROM m_pogodbe
LEFT OUTER JOIN nnprivez ON m_pogodbe.id_privez=nnprivez.id_privez
LEFT OUTER JOIN plovila p ON m_pogodbe.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
       WHERE m_pogodbe.datum_zacetka <= {?dTo} AND m_pogodbe.datum_konca >= {?dFrom}
AND m_pogodbe.status IN ('O', 'P')
--       AND nnprivez.occupancy_statistics='Y'
AND (SELECT count(*) FROM m_vzorci_ps WHERE m_vzorci_ps.id_pogodbe=m_pogodbe.id_pogodbe AND m_vzorci_ps.storitev = '42' and m_vzorci_ps.kat in ('1','2')) > 0
ORDER BY 1,7
) a
LEFT OUTER JOIN m_nnkateg ON a.kat=m_nnkateg.sifra and m_nnkateg.sifra_sklopa='3'
;

-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------
-- CASUAL VESSELS
-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------
INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 8001, 'CASUAL VESSELS', 0);

INSERT INTO report_sql (computer, num1, str1, str2, num20)
SELECT {?Computer}, rownum+8001, a.*, 7 FROM (
SELECT case WHEN (nntip.opis) IS NULL THEN '<unknown>' ELSE nntip.opis END, count(*)
FROM rezervac_detail
JOIN rezervac ON rezervac_detail.id_rezervac=rezervac.id
LEFT OUTER JOIN plovila ON rezervac.id_plovila=plovila.id
LEFT OUTER JOIN nntip ON plovila.ntip=nntip.sifra
LEFT OUTER JOIN nnprivez ON rezervac_detail.id_privez=nnprivez.id_privez
WHERE rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >={?dFrom}
AND rezervac_detail.status_rezervac = 1
AND rezervac_detail.complete='Y'
AND rezervac.storno IS NULL
AND rezervac.vrsta = 'TR'
AND nnprivez.occupancy_statistics='Y'
GROUP BY nntip.opis
ORDER BY nntip.opis) a
;

INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 8101, 'Total', 8);

UPDATE report_sql SET str2 = (SELECT trim(to_char(sum(to_number(str2)),'9,990')) FROM report_sql WHERE computer={?Computer} AND num1 BETWEEN 8002 AND 8100)
WHERE num1=8101 AND computer={?Computer};

-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, num20)
SELECT {?Computer}, 8105, rownum, null, a.privez, a.ime, a.kupec, a.datum_od, a.datum_do, a.n_racuna, 10 FROM (
SELECT null kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, 
       rezervac_detail.datum_od, rezervac_detail.datum_do, CASE WHEN nntip.opis IS NULL THEN '<unknown>' ELSE nntip.opis END n_racuna, nnprivez.n_priveza privez
FROM rezervac_detail
JOIN rezervac ON rezervac_detail.id_rezervac=rezervac.id
LEFT OUTER JOIN plovila p ON rezervac.id_plovila=p.id
LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
LEFT OUTER JOIN nntip ON p.ntip=nntip.sifra
LEFT OUTER JOIN nnprivez ON rezervac_detail.id_privez=nnprivez.id_privez
WHERE rezervac_detail.datum_od <= {?dTo} AND rezervac_detail.datum_do >={?dFrom}
AND rezervac_detail.status_rezervac = 1
AND rezervac_detail.complete='Y'
AND rezervac.storno IS NULL
AND rezervac.vrsta = 'TR'
AND nnprivez.occupancy_statistics='Y'
ORDER BY nntip.opis,nnprivez.n_priveza) a
LEFT OUTER JOIN m_nnkateg ON a.kat=m_nnkateg.sifra and m_nnkateg.sifra_sklopa='3'
;

INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 8201, 'Paid Casual Nights in current period', 9);

-- tole je iz Occupancy&EfficiencyStatistics (spremenjen status=1,3,4 in ne 0,1,3,4; dodan Storno is null)
UPDATE report_sql SET str2 = trim(to_char(
       nvl((SELECT sum(st_zased_dni) FROM (
             select 
                 case when r.datum_od = r.datum_do then 0
                 when r.datum_od < {?dFrom} then 
                     case when r.datum_do < {?dTo} then r.datum_do - {?dFrom}
                                                   else {?dTo} - {?dFrom}
                     end
                 when r.datum_od >= {?dFrom} then
                     case when r.datum_do < {?dTo} then r.datum_do - r.datum_od
                                                   else {?dTo} - r.datum_od 
                     end
                 end as st_zased_dni
             from rezervac_detail r INNER JOIN rezervac rzr on r.ID_REZERVAC = rzr.ID and rzr.vrsta='TR' AND rzr.storno IS NULL
             join nnprivez on r.id_privez=nnprivez.id_privez
             where r.status_rezervac in (1,3,4)
             and (r.datum_od < {?dTo} and r.datum_do > {?dFrom} or
                  r.datum_od = r.datum_do and r.datum_od = {?dFrom})
	     and occupancy_statistics = 'Y'
             )),0),'9,990'))
WHERE num1=8201 AND computer={?Computer};

-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, num20)
SELECT {?Computer}, 8205, rownum, null, a.privez, a.ime, a.kupec, a.datum_od, a.datum_do, a.n_racuna, 10 FROM (
        select null kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, r.datum_od, r.datum_do,
        'Nights: ' || trim(to_char(case when r.datum_od = r.datum_do then 0
                 when r.datum_od < {?dFrom} then 
                     case when r.datum_do < {?dTo} then r.datum_do - {?dFrom}
                                                   else {?dTo} - {?dFrom}
                     end
                 when r.datum_od >= {?dFrom} then
                     case when r.datum_do < {?dTo} then r.datum_do - r.datum_od
                                                   else {?dTo} - r.datum_od 
                     end
                 end,'9,990')) as n_racuna, nnprivez.n_priveza privez
        from rezervac_detail r INNER JOIN rezervac rzr on r.ID_REZERVAC = rzr.ID and rzr.vrsta='TR' AND rzr.storno IS NULL
        join nnprivez on r.id_privez=nnprivez.id_privez
        LEFT OUTER JOIN plovila p ON rzr.id_plovila=p.id
        LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
        where r.status_rezervac in (1,3,4)
             and (r.datum_od < {?dTo} and r.datum_do > {?dFrom} or
                  r.datum_od = r.datum_do and r.datum_od = {?dFrom})
             and occupancy_statistics = 'Y'
        ORDER BY nnprivez.n_priveza) a
;


INSERT INTO report_sql (computer, num1, str1, num20)
VALUES ({?Computer}, 8301, 'Paid Casual Nights from ' || to_char({?dTo}+1,'dd/mm/yyyy') || ' on', 9);

UPDATE report_sql SET str2 = trim(to_char(
       nvl((SELECT sum(st_zased_dni) FROM (
             select 
                 case when r.datum_od = r.datum_do then 0
                      when r.datum_od < {?dTo}+1 then r.datum_do - {?dFrom}
                      when r.datum_od >= {?dTo}+1 then r.datum_do - r.datum_od
                 end as st_zased_dni
             from rezervac_detail r INNER JOIN rezervac rzr on r.ID_REZERVAC = rzr.ID and rzr.vrsta='TR' AND rzr.storno IS NULL
             join nnprivez on r.id_privez=nnprivez.id_privez
             where r.status_rezervac in (1,3,4)
             and r.datum_od > {?dTo}
	     and occupancy_statistics = 'Y'
             )),0),'9,990'))
WHERE num1=8301 AND computer={?Computer};

-- detail vrstice
INSERT INTO report_sql (computer, num1, num2, str2, str3, str4, str5, date1, date2, str6, num20)
SELECT {?Computer}, 8305, rownum, null, a.privez, a.ime, a.kupec, a.datum_od, a.datum_do, a.n_racuna, 10 FROM (
        select null kat, p.ime ime, trim(k.ime || ' ' || k.priimek) kupec, r.datum_od, r.datum_do,
        'Nights: ' || trim(to_char(case when r.datum_od = r.datum_do then 0
                      when r.datum_od < {?dTo}+1 then r.datum_do - {?dFrom}
                      when r.datum_od >= {?dTo}+1 then r.datum_do - r.datum_od
                 end,'9,990')) as n_racuna, nnprivez.n_priveza privez
        from rezervac_detail r INNER JOIN rezervac rzr on r.ID_REZERVAC = rzr.ID and rzr.vrsta='TR' AND rzr.storno IS NULL
        join nnprivez on r.id_privez=nnprivez.id_privez
        LEFT OUTER JOIN plovila p ON rzr.id_plovila=p.id
        LEFT OUTER JOIN kupci K ON p.id_lastnika=k.id
        where r.status_rezervac in (1,3,4)
             and r.datum_od > {?dTo}
             and occupancy_statistics = 'Y'
        ORDER BY nnprivez.n_priveza) a
;

UPDATE report_sql r1 SET r1.date3=(SELECT r2.date3 FROM report_sql r2 WHERE r1.computer=r2.computer AND r2.num1=1),
                         r1.date4=(SELECT r2.date4 FROM report_sql r2 WHERE r1.computer=r2.computer AND r2.num1=1)
WHERE num1 > 1 AND computer={?Computer};
